/// <reference types="typed-graphql" />
import { OpaqueToken } from '@angular/core';
import { ApolloClient, ApolloQueryResult, WatchQueryOptions, MutationOptions, SubscriptionOptions } from 'apollo-client';
import { Observable } from 'rxjs/Observable';
import { FragmentDefinition } from 'graphql';
import { ApolloQueryObservable } from './ApolloQueryObservable';
export interface DeprecatedWatchQueryOptions extends WatchQueryOptions {
    fragments?: FragmentDefinition[];
}
export declare const ApolloClientWrapper: OpaqueToken;
export declare const ApolloClientInstance: OpaqueToken;
export declare class Angular2Apollo {
    private client;
    constructor(client: ApolloClient);
    watchQuery(options: DeprecatedWatchQueryOptions): ApolloQueryObservable<ApolloQueryResult>;
    query(options: DeprecatedWatchQueryOptions): Observable<ApolloQueryResult>;
    mutate(options: MutationOptions): Observable<ApolloQueryResult>;
    subscribe(options: SubscriptionOptions): Observable<any>;
}
