import { NgModule } from '@angular/core';
import { Angular2Apollo, ApolloClientWrapper, ApolloClientInstance } from './Angular2Apollo';
import { SelectPipe } from './SelectPipe';
export var /** @type {?} */ APOLLO_DIRECTIVES = [
    SelectPipe,
];
export var /** @type {?} */ APOLLO_PROVIDERS = [
    Angular2Apollo,
];
/**
 * @param {?} clientFn
 * @return {?}
 */
export function getApolloClient(clientFn) {
    return clientFn();
}
/**
 * @param {?} clientFn
 * @return {?}
 */
export function defaultApolloClient(clientFn) {
    return [{
            provide: ApolloClientWrapper,
            useValue: clientFn,
        }, {
            provide: ApolloClientInstance,
            useFactory: getApolloClient,
            deps: [ApolloClientWrapper],
        }];
}
export var ApolloModule = (function () {
    function ApolloModule() {
    }
    /**
     * @param {?} clientFn
     * @return {?}
     */
    ApolloModule.withClient = function (clientFn) {
        return {
            ngModule: ApolloModule,
            providers: [
                APOLLO_PROVIDERS,
                defaultApolloClient(clientFn),
            ],
        };
    };
    ApolloModule.decorators = [
        { type: NgModule, args: [{
                    declarations: APOLLO_DIRECTIVES,
                    exports: APOLLO_DIRECTIVES,
                },] },
    ];
    /** @nocollapse */
    ApolloModule.ctorParameters = function () { return []; };
    return ApolloModule;
}());
function ApolloModule_tsickle_Closure_declarations() {
    /** @type {?} */
    ApolloModule.decorators;
    /**
     * @nocollapse
     * @type {?}
     */
    ApolloModule.ctorParameters;
}
//# sourceMappingURL=ApolloModule.js.map